import PrismRPGItemSheet from "./base-item-sheet.mjs"

export default class PrismRPGContainerSheet extends PrismRPGItemSheet {
  /** @override */
  static DEFAULT_OPTIONS = {
    classes: ["container"],
    position: {
      width: 600,
    },
    window: {
      contentClasses: ["container-content"],
    },
  }

  /** @override */
  static PARTS = {
    main: {
      template: "systems/fvtt-prism-rpg/templates/container.hbs",
    },
  }

  /** @override */
  tabGroups = {
    primary: "details",
  }

  #getTabs() {
    const tabs = {
      details: { id: "details", group: "primary", label: "PRISMRPG.Label.details" },
      description: { id: "description", group: "primary", label: "PRISMRPG.Label.description" },
      effects: { id: "effects", group: "primary", label: "PRISMRPG.Label.effects" },
    }
    for (const v of Object.values(tabs)) {
      v.active = this.tabGroups[v.group] === v.id
      v.cssClass = v.active ? "active" : ""
    }
    return tabs
  }

  /** @override */
  async _prepareContext() {
    const context = await super._prepareContext()
    context.tabs = this.#getTabs()
    context.enrichedDescription = await foundry.applications.ux.TextEditor.implementation.enrichHTML(
      this.document.system.description, { async: true }
    )
    context.enrichedNotes = await foundry.applications.ux.TextEditor.implementation.enrichHTML(
      this.document.system.notes, { async: true }
    )
    return context
  }
}
